{###################################################}
{# PRACTICA: 1                                     #}
{# NUMERO DE GRUPO: 50                             #}
{# COMPONENTES: Alejandro Dobeson Beirao           #}
{###################################################}

program ppt;

{# Con este programa se puede jugar a              #}
{# piedra, papel, tijera                           #}

uses crt;

var

{# Variables:                                      #}
{# opcion - Opcion del jugador                     #}
{# copcion - Opcion del computador                 #}
{# PartidasJugador - Victorias del jugador         #}
{# PartidasOrdenador - Victorias de la computadora #}
{# PartidasEmpate - Partidas empatadas             #}
{# resultado - Resultado de la partida             #}
{# n1 - Eleccion del jugador (palabra)             #}
{# n2 - Eleccion del computador (palabra)          #}

opcion, copcion, PartidasJugador, PartidasOrdenador, PartidasEmpate: integer;
resultado, n1, n2: string;

{################## SUBPROGRAMAS ###################}

{# Subprograma para el juego en si. J1 sera la     #}
{# opcion del jugador, J2 sera la opcion del       #}
{# ordenador, y R el resultado del juego. El       #}
{# codigo para las opciones de juego es la misma   #}
{# que en el resto del programa. 1 piedra, 2 papel #}
{# y 3 tijera.                                     #}

procedure juego(j1, j2:integer; var r: string);

begin
  if j1 = 1 then
   begin
    if j2 = 1 then
      r:='EMPATE';
    if j2 = 2 then
      r:='PIERDES';
    if j2 = 3 then
      r:='GANAS';
   end;
  if j1 = 2 then
   begin
    if j2 = 1 then
      r:='GANAS';
    if j2 = 2 then
      r:='EMPATE';
    if j2 = 3 then
      r:='PIERDES';
   end;
  if j1 = 3 then
   begin
    if j2 = 1 then
      r:='PIERDES';
    if j2 = 2 then
      r:='GANAS';
    if j2 = 3 then
      r:='EMPATE';
   end;
end;

{# Subprograma para embellecer el aspecto final    #}
{# del programa. Identifica los numeros con la     #}
{# opcion correspondiente para ensearlos al final #}
{# N es el numero de la opcion y identidad es el   #}
{# nombre que le corresponde.                      #}

procedure Identificador(n: integer; var identidad: string);

begin
  if n = 1 then
    identidad:='piedra';
  if n = 2 then
    identidad:='papel';
  if n = 3 then
    identidad:='tijera';
end;

{#################### PROGRAMA #####################}

begin
  randomize;
  clrscr;
  writeln('############################');
  writeln;
  writeln('   Piedra, papel y tijera');
  writeln;
  writeln('############################');
  repeat
  writeln;
  copcion:= random(3) + 1;
  writeln('Elige tu opcion:');
  writeln;
  writeln('1. Piedra');
  writeln('2. Papel');
  writeln('3. Tijera');
  writeln('0. Salir');
  writeln;
  readln(opcion);
  if (opcion > 3) then
    begin
      writeln;
      writeln('Introduzca una eleccion valida.')
    end;
  if (opcion > 0) and (opcion < 4) then
    begin
      writeln;
      juego(opcion, copcion, resultado);
      identificador(opcion, n1);
      identificador(copcion, n2);
      writeln('Tu opcion fue ', n1);
      writeln('Su opcion fue ', n2);
      writeln('Resultado: ', resultado);
      if (resultado = 'GANAS') then
        begin
          PartidasJugador:= PartidasJugador + 1;
        end;
      if (resultado = 'PIERDES') then
        begin
          PartidasOrdenador:= PartidasOrdenador + 1;
        end;
      if (resultado = 'EMPATE') then
        begin
          PartidasEmpate:= PartidasEmpate + 1;
        end;
      writeln;
      writeln('############################');
      writeln('         Puntuacion');
      writeln('############################');
      writeln;
      writeln('Jugador:     ', PartidasJugador);
      writeln('Ordenador:   ', PartidasOrdenador);
      writeln('Empates:     ', PartidasEmpate);
    end
  until opcion = 0
end.